%%% fake report?
\ProvidesClass{myreport}[2023-12-01, v01]

\LoadClass[a4paper,11pt,twoside,openany]{oblivoir}

\RequirePackage[a4]{fapapersize}
\evenmarginsameasodd

\RequirePackage{iftex}
\ifx\ifXeTeX\ifLuaTeX
\let\envfont\ttfamily
\else
\setkomainfont(Noto Serif CJK KR)[Scale=MatchUppercase]
\setkosansfont(Noto Sans CJK KR)[Scale=MatchUppercase]
\usepackage{libertine}
\setmonofont{Inconsolatazi4}
\setkomonofont(D2Coding)[Scale=.92]
\newfontfamily\envfont{TeX Gyre Cursor}[Scale=.9]
\fi

\let\cleartorecto\clearpage
\let\cleartoverso\clearpage

\newcommand*\pkg[1]{\textsf{#1}}
\newcommand*\doc[1]{\textsc{#1}}
\newcommand*\env[1]{<{\envfont #1}>}
\newcommand*\kemph[1]{\dotemph{\em #1}}
\newcommand*\opt[1]{\texttt{#1}}

\ExplSyntaxOn
%%% srcandtext
	\skip_new:N \g_preexample_skip
	\skip_gset:Nn \g_preexample_skip { 0pt plus 1pt minus 1pt }

	\RequirePackage { tcolorbox }
	\tcbuselibrary{minted,breakable}
	\tcbset{
		listing~engine=minted,
		colframe=cyan,
		colback=cyan!5!white,
		minted~options={tabsize=4,
			fontsize=\normalsize,breaklines},
	}
	
	\NewDocumentEnvironment { exampleonly } {}
    {
        \par
        \vspace { \g_preexample_skip }
%        \renewcommand\baselinestretch{ \opt_bvlskip_tl }
		\SingleSpacing
        \tcblisting {listing~only,breakable,after={\par\normalcolor}}
    }{
        \endtcblisting
        \relax
    }

    \NewDocumentEnvironment {exampleside} {}
    {%
        \par
        \vspace { \g_preexample_skip }
%        \renewcommand\baselinestretch{ \opt_bvlskip_tl }
		\SingleSpacing
        \tcblisting{listing~side~text,
        	righthand~width=.36\textwidth,after={\par\normalcolor}}
    }{%
        \endtcblisting
    }

    \NewDocumentEnvironment {examplebelow} {}
    {%
        \par
        \vspace { \g_preexample_skip }
%        \renewcommand\baselinestretch{ \opt_bvlskip_tl }
		\SingleSpacing
	    \tcblisting{breakable,after={\par\normalcolor}}
    }{%
        \endtcblisting
    }


    \NewDocumentEnvironment {demohigh} {O{.4}}
    {%
        \par
        \vspace { \g_preexample_skip }
%        \renewcommand\baselinestretch{ \opt_bvlskip_tl }
		\SingleSpacing
        \tcblisting{listing~side~text,
        	righthand~width=#1\textwidth,after={\par\normalcolor}}
    }{%
        \endtcblisting
    }

    \NewDocumentEnvironment {codedemo} {}
    {%
        \par
        \vspace { \g_preexample_skip }
%        \renewcommand\baselinestretch{ \opt_bvlskip_tl }
		\SingleSpacing
	    \tcblisting{breakable,colback=yellow!8,after={\par\normalcolor}}
    }{%
        \endtcblisting
    }

	\NewDocumentEnvironment { codeonly } {}
    {
        \par
        \vspace { \g_preexample_skip }
%        \renewcommand\baselinestretch{ \opt_bvlskip_tl }
		\SingleSpacing
        \tcblisting {listing~only,breakable,colback=yellow!8,after={\par\normalcolor}}
    }{
        \endtcblisting
        \relax
    }

\ExplSyntaxOff

\endinput
